APPBASE="webgnumed_test1"
BASEDIR='/var/www/'+APPBASE
INTERNAL_APPURL="http://localhost/"+APPBASE
host = 'localhost'
port=5435
dbname='gnumed_v4'
conn = None

import os.path
from mod_python import Session
global session

def locale():
	from Gnumed.pycommon import gmI18N 
	gmI18N.activate_locale()
	#print "system locale: ", system_locale, "; levels:", system_locale_level
	gmI18N.install_domain()
	# == do not remove this line =============================
	tmp = _('translate this or i18n will not work properly !')
	# ========================================================


def __getfile(filename):
	return file(os.path.join(BASEDIR,filename),'r')

def show(filename):
	return __getfile(filename).read()


def showlogin(req):
	return show('login.html')


def login(req, username, password):
	return do_real_login(req , username, password)

def do_real_login(req, username, password):
	from gnumed.client.pycommon import gmPG2
	dsn = 'host=%s port=%d dbname=%s user=%s password=%s' % ( host, port, dbname, username, password)
	con = None
	try:
		con = gmPG2.get_connection(dsn)
	except:
		pass

	session = Session.Session(req)
	if con :
		session['dsn'] = dsn
		session.save()
		con.close()
		return login_success(req)
	else:
		session['dsn'] = None
		session.save()
		return login_failed(req)	

def login_success(req):
	return main(req)

def login_failed(req):
	return show('loginfailed.html')

def login_expired(req):
	return show('loginexpired.html')
	
def main(req):
	return show('mainmenu.html')

def administration(req):
	return show('administration.html')

def find_patient(req):
	return show('findpatient.html')

def write_cells(buffer, *kargs):
	for x in kargs:
		buffer.write('<td>')
		buffer.write(str(x))
		buffer.write('</td>')

def get_href( link, title, **kargs):
	l = []
	for k,v in kargs.items():
		l.append('%s=%s' % (k,v) )
	s = '&'.join(l)
	return '<a href="%s?%s">%s</a>' % (link,  s, title)
		
def connect(req):
	from Gnumed.pycommon import gmPG2, gmI18N
	global session
	session= Session.Session(req)
	dsn = None
	try:	
		dsn = session['dsn']
		gmPG2._default_dsn =dsn
	except:
		pass
	
	return dsn <> None

def return_demosearch(req):
	return do_find_patient(req)

def do_find_patient(req, name_fragment = None ):
	from Gnumed.pycommon import gmPG2
	if not connect(req):
		return login_expired(req)
	from Gnumed.business import *
	
	if name_fragment:
		session['last_demo_search'] = name_fragment
		session.save()
	else:
		name_fragment = session['last_demo_search']

	from Gnumed.business.gmPerson import cPatientSearcher_SQL as Searcher

	locale()
	#searcher = Searcher()
	
	#patients = searcher.get_identities(name_fragment)
	
	conn = gmPG2.get_connection()
	cu = conn.cursor()
	frags =[x.strip() for x in  name_fragment.split(',')]

	if len(frags) == 1:
		frags.append('')
	

	stmt2 = "select pk_identity as id, title, lastnames, firstnames, dob, gender, number, street, urb, state, postcode from dem.v_pat_addresses where lastnames ilike '%%%s%%' and firstnames ilike '%%%s%%' " % (frags[0], frags[1] )
	cu.execute(stmt2)
	res2 = cu.fetchall()
	conn.close()
	conn = None
	keys =  "id, title, lastnames, firstnames, dob, gender, number, street, urb, state, postcode"
	keys = keys.split(', ')

	patients = []
	for r in res2:
		p = dict( [ (k, v) for k,v in zip ( keys, r) ] )
		patients.append(p)
		
		
	# this sort replaced when query customized to sql
	def pat_sort(p1, p2):
		if p1['lastnames'] < p2['lastnames']:
			return -1
		if p1['lastnames'] > p2['lastnames']:
			return 1

		if p1['gender'] < p2['gender']:
			return -1
		if p1['gender'] > p2['gender']:
			return 1

		if p1['firstnames'] < p2['firstnames']:
			return -1
		if p1['firstnames'] > p2['firstnames']:
			return 1

		if p1['dob'] < p2 ['dob']:
			return -1
		return 1
	#patients.sort(pat_sort)

	
	import StringIO
	sf = StringIO.StringIO()

	ID = 'id'

	for l in __getfile('findpatient.html'):
		if l.find('/body') < 0:
			sf.write(l)
		else:
			sf.write('<br/><br/>Search Term was %s' % name_fragment)		
			sf.write('<br/><br/><table border=1>')
			sf.write('<th>Surname(s)</th><th>Firstname(s)</th><th>Birth Date</th><th>address</th>')		
			
			for p in patients:
				
				sf.write('<tr>')
			
				
				write_cells(sf, p['lastnames'], p['firstnames'], p['dob'].strftime('%x'),", ".join( [ p['number'], p['street'] , p['urb'], p['state'], p['postcode'] ] ))
				write_cells(sf, 
					get_href('demographic', 'demographic', id=p[ID]),
					get_href('clinical', 'clinical', id=p[ID]),
					get_href('appointments', 'appointments', id=p[ID]),
					get_href('billing', 'billing', id=p[ID] ) 
					)
				sf.write('</tr>')

				#address = p.get_addresses('home')
			sf.write('</table>')

			sf.write(l)

	s = sf.getvalue()
	return s

def get_input( title, name, value, type= 'text' , newline=True, readonly = False  ):
	if readonly :
		readonly = 'readonly=1'
	else:
		readonly = ''
	s = """<b>%s</b>: <input type='%s' name='%s' value='%s' %s/>""" % ( title, type, name, value, readonly )
	if newline:
		s += "<br/>"
	return s

def demographic( req, id):
	if not connect(req):
		return login_expired(req)
	from Gnumed.business import gmPerson
	import StringIO
	
	sf = StringIO.StringIO()
	

	if id:
		p = gmPerson.cPerson(id).get_identity()
		a = p.get_addresses()
		if type(a) is type([]) and len(a):
				a  =  a[0]
				comms = p.get_comm_channels()
				# comm_type, url, is_confidential
				comdict = dict( [ ( c['comm_type'], {'url':c['url'],'is_confidential': c['is_confidential']})  for c in comms ] )
		else:
				a = { 'number' : '', 'street': '', 'urb' : '', 'state': '', 'postcode' :'' , 'country': 'AU',  'pk_address' : 0 }
				comms = []
		
		sf.write( get_input( 'id', 'pk_identity', p['pk_identity'], readonly=True) )	
		sf.write( get_input( 'Last Names', 'lastnames', p['lastnames']) )	
		sf.write( get_input( 'First Names', 'firstnames', p['firstnames']) )	
		sf.write( get_input( 'birth date', 'dob', p['dob']) )	
		sf.write( get_input( 'gender', 'gender', p['gender']) )	
		sf.write( get_input( 'Street No', 'number', a['number'] ))	
		sf.write( get_input( 'Street', 'street', a['street'] ))	
		sf.write( get_input( 'urb' , 'urb', a['urb'] , newline = False)  )
		sf.write( get_input ( 'postcode', 'postcode', a['postcode'] ) ) 	
		sf.write( get_input( 'state' , 'state', a['state'] ))
		sf.write( get_input( 'country' , 'country', a['country'] ))
		
		

		#sf.write( get_input( '', 'pk_address', a['pk_address'] , type='hidden'))
		for t in ['homephone', 'workphone', 'mobile'] :
			if not comdict.has_key(t):
				comdict[t] = {'url':'' , 'is_confidential': 'f' }
			sf.write(get_input( t, t, comdict[t]['url'], newline = False))
			sf.write( get_input( "is_confidential", "%s_is_confidential" % t, comdict[t]['is_confidential'], type= "checkbox" ) )

			
		sf.write( '<input type="submit"/>')

	

	whole = show("demographic.html") % sf.getvalue()
	
	flds1 = 'pk_identity lastnames firstnames dob gender'.split(' ')
	
	flds2 = 'number street urb postcode state country pk_address'.split(' ')
	flds3 = 'homephone workphone mobile'.split( ' ')
	
	store = {}
	store.update( dict( [ (k,p[k]) for k in  flds1]) )
	store.update( dict( [ (k,a[k]) for k in flds2]) )
	store.update( dict( [ (k,comdict[k]['url']) for  k in flds3]) )
	store.update( dict( [ (k+'_is_confidential',comdict[k]['is_confidential']) for  k in flds3]) )

	store['dob'] = str(store['dob'])
	# use the global store, otherwise instantiating session twice in one request might lock things up
	session['old_demo'] = store
	session.save()

	return whole

def update_demographic( req, pk_identity, lastnames, firstnames, dob, gender, number, street, urb, postcode, state, country, homephone = None, homephone_is_confidential = False, workphone = None, workphone_is_confidential = False, mobile= None, mobile_is_confidential = False ):
	
	if not connect(req):
		return login_expired(req)
	
	global session
	old_demo = session['old_demo']
	if int(old_demo['pk_identity']) == int(pk_identity):
		cond1 = 'pk_identity is ok  : '
	else:
		cond1  = 'PK DOES NOT MATCH. %d %s' % ( old_demo['pk_identity'] , pk_identity)

	from Gnumed.business import gmPerson
	iden = gmPerson.cPerson(pk_identity)
	p = iden.get_identity()
		
	new_l = [  pk_identity, lastnames, firstnames, dob, gender, number, street, urb, postcode, state, homephone , homephone_is_confidential , workphone , workphone_is_confidential , mobile, mobile_is_confidential  ]	
	new_l = [ (type(x)==str and x.strip()) or x for x in new_l]

	old_k = "pk_identity, lastnames, firstnames, dob, gender, number, street, urb, postcode, state, homephone, homephone_is_confidential, workphone, workphone_is_confidential, mobile, mobile_is_confidential".split(', ')
	changed = []
	for new_v, k in zip(new_l, old_k):
		if new_v <> old_demo[k]:
			changed.append( {'name': k, 'old': old_demo[k], 'new':new_v })

	dob_changed, name_changed, address_changed, phone_changed= False, False, False, False

	# process dob changes 
	for d in changed:
		if  d['name'] == 'dob':
			s = d['new'].split()
			if len(s) > 1:
				s = s[0]
			t = None
			for c in '/ - .'.split(' '):
				if len( s.split(c) ) == 3:
					import time
					t = time.strptime(s, '%%Y%s%%m%s%%d' %(c,c) )
					break
			if t :	
				import datetime
				ZERO = datetime.timedelta(0)
				HOUR = datetime.timedelta(hours=1)

				# A UTC class.

				class UTC(datetime.tzinfo):
				    """UTC"""

				    def utcoffset(self, dt):
					return ZERO

				    def tzname(self, dt):
					return "UTC"

				    def dst(self, dt):
					return ZERO
					
				p['dob'] = datetime.datetime( t[0], t[1], t[2], 0,0,0,0, UTC() )
				dob_changed= True
				p.save_payload()

	# process name changes

	n = dict ( [ (k,old_demo[k] ) for k in 'lastnames firstnames'.split(' ') ] )
	for d in changed:
		for k in 'lastnames firstnames'.split(' '):

			if d['name'] == k:
				n[k] = d['new']
				name_changed = True
	

	if name_changed:
		p.add_name( n['firstnames'], n['lastnames'] )

			
	#process phone changes
	for k in 'homephone workphone mobile'.split(' '):
		url = [ d['new'] for d in changed if d['name'] == k]
		is_confidential = [d['new'] for d in changed if d['name'] == k+'_is_confidential']
		
		url = len(url) and url[0] 
		is_confidential = len(is_confidential) and is_confidential[0]
		if url or is_confidential:	
			url = url or old_demo[k]
			is_confidentil = is_confidential or 	old_demo[k+'_is_confidential']
			p.link_communication( 	k, url, bool(is_confidential) )
			phone_changed = True
		
		

	# process address changes
	addr_kk = 'number, street, urb, postcode, state'.split(', ')
	addr_changed = [ mv for mv in changed if mv['name'] in addr_kk]
	from Gnumed.pycommon import gmPG2
	if addr_changed <> [] :
		
		def normalize_to_codes(state, country):
			con = gmPG2.get_connection()
			cu = con.cursor()
			cu.execute("select code from dem.state where name like '%s'" % state)
			r = cu.fetchall()
			if len(r) :
				state = str(r[0][0] )

			cu.execute("select code from dem.country where name like '%s'" % country)
			r = cu.fetchall()
			if len(r):
				country = str(r[0][0])

			con.close()
			return state, country

		state, country = normalize_to_codes(state, country)

		if p.link_address( number, street, postcode, urb, state, country ):
			# remove old records
			def remove_old_address():
				con = gmPG2.get_raw_connection()
				cu = con.cursor()
				cu.execute("delete from dem.lnk_person_org_address where id_identity = %d and id_address = %d " % ( int(old_demo['pk_identity']), int(old_demo['pk_address']) ) )
				con.commit()
				con.close()
			
			remove_old_address()
			address_changed = True
		else:
			return show('failed_link_address.html')

	if name_changed or dob_changed or address_changed or phone_changed:
			return show('demographic_updated.html')
		

	return show('demographic_unchanged.html')
	#return '<html><body>%s</body></html>' % ' '.join([ cond1, lastnames, firstnames,dob, gender, number, street, urb, postcode, state, homephone, str(homephone_is_confidential ), workphone, str(workphone_is_confidential), mobile, str( mobile_is_confidential ) ] )

def clinical (req, id):
	return clinical_past_notes(req, id)

def clinical_past_notes(req, pk_identity ):
	if not connect(req):
		return login_expired(req)
	from Gnumed.business import gmPerson
	from Gnumed.exporters import gmPatientExporter
	import StringIO
	
	sf = StringIO.StringIO()
	
	sf.write('<html><body>\n')


	pat = gmPerson.cPatient( pk_identity)
	cur_pat = gmPerson.gmCurrentPatient(pat)
	exporter = gmPatientExporter.cEMRJournalExporter()

	ef = StringIO.StringIO()

	exporter.export(ef)
	
	dump = ef.getvalue()
	ll = dump.split('\n')
	for l in ll[0:3]:
		sf.write('<h5>%s</h5>' % l)
	
	sf.write('<table border=1>\n')

	xx = ll[6].split('|')
	for x in xx[1:]:
		sf.write('<th>%s</th' % x)
	
	coloring = { 's':'green', 'o':'orange', 'a': 'red', 'p': 'blue' }

	for l in ll[8:]:
		xx = l.split('|')
		sf.write('<tr>')
		if len(xx) > 1 and  xx[1].strip() <> '':
			sf.write( '<td>-</td>' * (len(xx) - 1) )
			sf.write('</tr><tr>')
		for i,x in enumerate( xx[1:]):
			
			sf.write('<td>')
			if i == 1 or i == 2:
				sf.write("<b><font color='%s'>" % coloring.get(x.lower().strip(), 'black'))	
			sf.write(x)
			if i == 1 or i == 2:
				sf.write("</font></b>")
			sf.write('</td>')
		sf.write('</tr>')
	
	sf.write('</table>\n')

	sf.write('<a href="return_demosearch">return </a>\n')
	sf.write('</body></html>\n')

	return sf.getvalue()
	
